//
// Publisher.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Publisher: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var userId: Int?
    public var name: String?
    public var website: String?
    public var logo: String?
    public var active: Bool?
    public var createdAt: Date?
    public var updatedAt: Date?
    public var user: User?
    public var syndications: [Syndication]?

    public init(id: Int? = nil, userId: Int? = nil, name: String? = nil, website: String? = nil, logo: String? = nil, active: Bool? = nil, createdAt: Date? = nil, updatedAt: Date? = nil, user: User? = nil, syndications: [Syndication]? = nil) {
        self.id = id
        self.userId = userId
        self.name = name
        self.website = website
        self.logo = logo
        self.active = active
        self.createdAt = createdAt
        self.updatedAt = updatedAt
        self.user = user
        self.syndications = syndications
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case userId
        case name
        case website
        case logo
        case active
        case createdAt
        case updatedAt
        case user = "User"
        case syndications = "Syndications"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(userId, forKey: .userId)
        try container.encodeIfPresent(name, forKey: .name)
        try container.encodeIfPresent(website, forKey: .website)
        try container.encodeIfPresent(logo, forKey: .logo)
        try container.encodeIfPresent(active, forKey: .active)
        try container.encodeIfPresent(createdAt, forKey: .createdAt)
        try container.encodeIfPresent(updatedAt, forKey: .updatedAt)
        try container.encodeIfPresent(user, forKey: .user)
        try container.encodeIfPresent(syndications, forKey: .syndications)
    }
}

